searchNodes=[{"doc":"Defines a currency structure and a set of functions to manage the validity of a currency code and to return metadata for currencies.","ref":"Cldr.Currency.html","title":"Cldr.Currency","type":"module"},{"doc":"","ref":"Cldr.Currency.html#annotated?/1","title":"Cldr.Currency.annotated?/1","type":"function"},{"doc":"Returns a map of the metadata for all currencies for a given locale. Arguments locale is any valid locale name returned by Cldr.known_locale_names/1 or a Cldr.LanguageTag struct returned by Cldr.Locale.new!/2 backend is any module that includes use Cldr and therefore is a Cldr backend module currency_status is :all , :current , :historic , unannotated or :tender ; or a list of one or more status. The default is :all . See Cldr.Currency.currency_filter/2 . Returns {:ok, currency_map} or {:error, {exception, reason}} Example =&gt; Cldr.Currency.currencies_for_locale &quot;en&quot;, MyApp.Cldr {:ok, %{ FJD : % Cldr.Currency { cash_digits : 2 , cash_rounding : 0 , code : &quot;FJD&quot; , count : %{ one : &quot;Fijian dollar&quot; , other : &quot;Fijian dollars&quot; } , digits : 2 , from : nil , iso_digits : 2 , name : &quot;Fijian Dollar&quot; , narrow_symbol : &quot;$&quot; , rounding : 0 , symbol : &quot;FJD&quot; , tender : true , to : nil } , SUR : % Cldr.Currency { cash_digits : 2 , cash_rounding : 0 , code : &quot;SUR&quot; , count : %{ one : &quot;Soviet rouble&quot; , other : &quot;Soviet roubles&quot; } , digits : 2 , from : nil , iso_digits : nil , name : &quot;Soviet Rouble&quot; , narrow_symbol : nil , rounding : 0 , symbol : &quot;SUR&quot; , tender : true , to : nil } , ... } }","ref":"Cldr.Currency.html#currencies_for_locale/4","title":"Cldr.Currency.currencies_for_locale/4","type":"function"},{"doc":"Returns a map of the metadata for all currencies for a given locale and raises on error. Arguments locale is any valid locale name returned by Cldr.known_locale_names/1 or a Cldr.LanguageTag struct returned by Cldr.Locale.new!/2 backend is any module that includes use Cldr and therefore is a Cldr backend module currency_status is :all , :current , :historic , unannotated or :tender ; or a list of one or more status. The default is :all . See Cldr.Currency.currency_filter/2 . Returns {:ok, currency_map} or raises an exception Example #=&gt; MyApp.Cldr.Currency.currencies_for_locale! &quot;en&quot; %{ FJD : % Cldr.Currency { cash_digits : 2 , cash_rounding : 0 , code : &quot;FJD&quot; , count : %{ one : &quot;Fijian dollar&quot; , other : &quot;Fijian dollars&quot; } , digits : 2 , from : nil , iso_digits : 2 , name : &quot;Fijian Dollar&quot; , narrow_symbol : &quot;$&quot; , rounding : 0 , symbol : &quot;FJD&quot; , tender : true , to : nil } , SUR : % Cldr.Currency { cash_digits : 2 , cash_rounding : 0 , code : &quot;SUR&quot; , count : %{ one : &quot;Soviet rouble&quot; , other : &quot;Soviet roubles&quot; } , digits : 2 , from : nil , iso_digits : nil , name : &quot;Soviet Rouble&quot; , narrow_symbol : nil , rounding : 0 , symbol : &quot;SUR&quot; , tender : true , to : nil } , ... }","ref":"Cldr.Currency.html#currencies_for_locale!/4","title":"Cldr.Currency.currencies_for_locale!/4","type":"function"},{"doc":"Return only those currencies meeting the filter criteria. Arguments currency is a Cldr.Currency.t , a list of Cldr.Currency.t or a map where the values of each item is a Cldr.Currency.t only is :all , :current , :historic , :tender unannotated or a list of one or more status or currency codes. The default is :all except is :current , :historic , :tender unannotated or a list of one or more status or currency codes. The default is nil Currency Status A currency may be in current use, of historic interest only. It may or may not be legal tender. And it may mostly be used as a financial instrument. To help return the most useful currencies the currency status code acts as follows: :all , the default, returns all currencies :current returns those currencies that have a :to date of nil and which also is a known ISO4217 currency :historic is the opposite of :current :tender is a currency that is legal tender :unannotated is a currency that doesn't have &quot;(some string)&quot; in its name. These are usually financial instruments.","ref":"Cldr.Currency.html#currency_filter/3","title":"Cldr.Currency.currency_filter/3","type":"function"},{"doc":"Returns the currency metadata for the requested currency code. Arguments currency_or_currency_code is a binary or atom representation of an ISO 4217 currency code, or a %Cldr.Currency{} struct. backend is any module that includes use Cldr and therefore is a Cldr backend module options is a Keyword list of options. Options :locale is any valid locale name returned by Cldr.known_locale_names/1 or a Cldr.LanguageTag struct returned by Cldr.Locale.new!/2 Examples iex&gt; Cldr.Currency . currency_for_code ( &quot;AUD&quot; , MyApp.Cldr ) { :ok , % Cldr.Currency { cash_digits : 2 , cash_rounding : 0 , code : &quot;AUD&quot; , count : %{ one : &quot;Australian dollar&quot; , other : &quot;Australian dollars&quot; } , digits : 2 , iso_digits : 2 , name : &quot;Australian Dollar&quot; , narrow_symbol : &quot;$&quot; , rounding : 0 , symbol : &quot;A$&quot; , tender : true } } iex&gt; Cldr.Currency . currency_for_code ( &quot;THB&quot; , MyApp.Cldr ) { :ok , % Cldr.Currency { cash_digits : 2 , cash_rounding : 0 , code : &quot;THB&quot; , count : %{ one : &quot;Thai baht&quot; , other : &quot;Thai baht&quot; } , digits : 2 , iso_digits : 2 , name : &quot;Thai Baht&quot; , narrow_symbol : &quot;฿&quot; , rounding : 0 , symbol : &quot;THB&quot; , tender : true } }","ref":"Cldr.Currency.html#currency_for_code/3","title":"Cldr.Currency.currency_for_code/3","type":"function"},{"doc":"Returns the effective currency format for a given locale Arguments locale a Cldr.LanguageTag struct returned by Cldr.Locale.new!/2 Returns Either :accounting or :currency Examples iex&gt; { :ok , locale } = Cldr . validate_locale &quot;en&quot; , MyApp.Cldr iex&gt; Cldr.Currency . currency_format_from_locale locale :currency iex&gt; { :ok , locale } = Cldr . validate_locale &quot;en-AU-u-cu-eur&quot; , MyApp.Cldr iex&gt; Cldr.Currency . currency_format_from_locale locale :currency iex&gt; { :ok , locale } = Cldr . validate_locale &quot;en-AU-u-cu-eur-cf-account&quot; , MyApp.Cldr iex&gt; Cldr.Currency . currency_format_from_locale locale :accounting","ref":"Cldr.Currency.html#currency_format_from_locale/1","title":"Cldr.Currency.currency_format_from_locale/1","type":"function"},{"doc":"Returns the effective currency for a given locale Arguments locale is a Cldr.LanguageTag struct returned by Cldr.Locale.new!/2 Returns A ISO 4217 currency code as an upcased atom Examples iex&gt; { :ok , locale } = Cldr . validate_locale &quot;en&quot; , MyApp.Cldr iex&gt; Cldr.Currency . currency_from_locale locale :USD iex&gt; { :ok , locale } = Cldr . validate_locale &quot;en-AU&quot; , MyApp.Cldr iex&gt; Cldr.Currency . currency_from_locale locale :AUD iex&gt; Cldr.Currency . currency_from_locale &quot;en-GB&quot; :GBP","ref":"Cldr.Currency.html#currency_from_locale/1","title":"Cldr.Currency.currency_from_locale/1","type":"function"},{"doc":"Returns the effective currency for a given locale Arguments locale is any valid locale name returned by Cldr.known_locale_names/1 backend is any module that includes use Cldr and therefore is a Cldr backend module. The default is Cldr.default_backend/0 Returns A ISO 4217 currency code as an upcased atom Examples iex&gt; Cldr.Currency . currency_from_locale &quot;fr-CH&quot; , MyApp.Cldr :CHF iex&gt; Cldr.Currency . currency_from_locale &quot;fr-CH-u-cu-INR&quot; , MyApp.Cldr :INR","ref":"Cldr.Currency.html#currency_from_locale/2","title":"Cldr.Currency.currency_from_locale/2","type":"function"},{"doc":"Returns a list of historic and the current currency for a given locale. Arguments locale is any valid locale name returned by Cldr.known_locale_names/1 or a Cldr.LanguageTag struct returned by Cldr.Locale.new!/2 backend is any module that includes use Cldr and therefore is a Cldr backend module Example iex&gt; Cldr.Currency . currency_history_for_locale &quot;en&quot; , MyApp.Cldr { :ok , %{ USD : %{ from : ~D[1792-01-01] , to : nil } , USN : %{ tender : false } , USS : %{ from : nil , tender : false , to : ~D[2014-03-01] } } }","ref":"Cldr.Currency.html#currency_history_for_locale/1","title":"Cldr.Currency.currency_history_for_locale/1","type":"function"},{"doc":"","ref":"Cldr.Currency.html#currency_history_for_locale/2","title":"Cldr.Currency.currency_history_for_locale/2","type":"function"},{"doc":"Returns a map that matches a currency string to a currency code. A currency string is a localised name or symbol representing a currency in a locale-specific manner. Arguments locale is any valid locale name returned by Cldr.known_locale_names/1 or a Cldr.LanguageTag struct returned by Cldr.Locale.new!/2 . :only is :all , :current , :historic , unannotated or :tender ; or a list of one or more status The default is :all . See Cldr.Currency.currency_filter/2 . Returns {:ok, currency_string_map} or {:error, {exception, reason}} Example =&gt; Cldr.Currency . currency_strings &quot;en&quot; , MyApp.Cldr { :ok , %{ &quot;mexican silver pesos&quot; =&gt; :MXP , &quot;sudanese dinar&quot; =&gt; :SDD , &quot;bad&quot; =&gt; :BAD , &quot;rsd&quot; =&gt; :RSD , &quot;swazi lilangeni&quot; =&gt; :SZL , &quot;zairean new zaire&quot; =&gt; :ZRN , &quot;guyanaese dollars&quot; =&gt; :GYD , &quot;equatorial guinean ekwele&quot; =&gt; :GQE , ... } } # Currencies match all currency status&#39; =&gt; Cldr.Currency . currency_strings &quot;en&quot; , MyApp.Cldr , [ :tender , :current , :unannotated ] { :ok , %{ &quot;rsd&quot; =&gt; :RSD , &quot;swazi lilangeni&quot; =&gt; :SZL , &quot;guyanaese dollars&quot; =&gt; :GYD , &quot;syrian pound&quot; =&gt; :SYP , &quot;scr&quot; =&gt; :SCR , &quot;bangladeshi takas&quot; =&gt; :BDT , &quot;netherlands antillean guilders&quot; =&gt; :ANG , &quot;pen&quot; =&gt; :PEN , ... } }","ref":"Cldr.Currency.html#currency_strings/4","title":"Cldr.Currency.currency_strings/4","type":"function"},{"doc":"Returns a map that matches a currency string to a currency code or raises an exception. A currency string is a localised name or symbol representing a currency in a locale-specific manner. Arguments locale is any valid locale name returned by Cldr.known_locale_names/1 or a Cldr.LanguageTag struct returned by Cldr.Locale.new!/2 . currency_status is :all , :current , :historic , unannotated or :tender ; or a list of one or more status. The default is :all . See Cldr.Currency.currency_filter/2 . Returns {:ok, currency_string_map} or raises an exception Example =&gt; Cldr.Currency . currency_strings! &quot;en&quot; , MyApp.Cldr %{ &quot;mexican silver pesos&quot; =&gt; :MXP , &quot;sudanese dinar&quot; =&gt; :SDD , &quot;bad&quot; =&gt; :BAD , &quot;rsd&quot; =&gt; :RSD , &quot;swazi lilangeni&quot; =&gt; :SZL , &quot;zairean new zaire&quot; =&gt; :ZRN , &quot;guyanaese dollars&quot; =&gt; :GYD , &quot;equatorial guinean ekwele&quot; =&gt; :GQE , ... }","ref":"Cldr.Currency.html#currency_strings!/4","title":"Cldr.Currency.currency_strings!/4","type":"function"},{"doc":"","ref":"Cldr.Currency.html#current?/1","title":"Cldr.Currency.current?/1","type":"function"},{"doc":"Returns the current currency for a given territory. Arguments territory is any valid territory name returned by Cldr.known_territories/0 Examples iex&gt; Cldr.Currency . current_currency_for_territory :US :USD iex&gt; Cldr.Currency . current_currency_for_territory :AU :AUD","ref":"Cldr.Currency.html#current_currency_for_territory/1","title":"Cldr.Currency.current_currency_for_territory/1","type":"function"},{"doc":"Returns the current currency from a given locale. This function does not consider the U extenion parameters cu or rg . It is recommended to us Cldr.Currency.currency_from_locale/1 in most circumstances. Arguments locale is any valid locale name returned by Cldr.known_locale_names/1 or a Cldr.LanguageTag struct returned by Cldr.Locale.new!/2 backend is any module that includes use Cldr and therefore is a Cldr backend module Examples iex&gt; Cldr.Currency . current_currency_from_locale &quot;en&quot; , MyApp.Cldr :USD iex&gt; Cldr.Currency . current_currency_from_locale &quot;en-AU&quot; , MyApp.Cldr :AUD","ref":"Cldr.Currency.html#current_currency_from_locale/1","title":"Cldr.Currency.current_currency_from_locale/1","type":"function"},{"doc":"","ref":"Cldr.Currency.html#current_currency_from_locale/2","title":"Cldr.Currency.current_currency_from_locale/2","type":"function"},{"doc":"Return the display name for a currency. The display name is useful for UI uses, for example in menus. The display name is typically capitalized for stand-alone use where as the display name returned by Cldr.Currency.pluralize/4 is typically lower-cased for use within sentences. Arguments currency is any currency code returned by Cldr.Currency.known_currencies/0 or a t:Cldr.Currency struct returned by Cldr.Currency.currency_for_code/3 Options :locale is any locale returned by Cldr.Locale.new!/2 . The default is Cldr.get_locale/0 :backend is any module that includes use Cldr and therefore is a Cldr backend module. The default is Cldr.default_backend!/0 Returns {:ok, display_name} or {:error, {exception, reason}} Examples iex&gt; Cldr.Currency . display_name :AUD , backend : MyApp.Cldr { :ok , &quot;Australian Dollar&quot; } iex&gt; Cldr.Currency . display_name &quot;AUD&quot; , backend : MyApp.Cldr , locale : &quot;fr&quot; { :ok , &quot;dollar australien&quot; } iex&gt; Cldr.Currency . display_name &quot;EUR&quot; , backend : MyApp.Cldr , locale : &quot;de&quot; { :ok , &quot;Euro&quot; } iex&gt; Cldr.Currency . display_name &quot;ZZZ&quot; , backend : MyApp.Cldr { :error , { Cldr.UnknownCurrencyError , &quot;The currency \\&quot; ZZZ \\&quot; is invalid&quot; } }","ref":"Cldr.Currency.html#display_name/2","title":"Cldr.Currency.display_name/2","type":"function"},{"doc":"Return the display name for a currency or raises and exception on error. The display name is useful for UI uses, for example in menus. The display name is typically capitalized for stand-alone use where as the display name returned by Cldr.Currency.pluralize/4 is typically lower-cased for use within sentences. Arguments currency is any currency code returned by Cldr.Currency.known_currencies/0 or a t:Cldr.Currency struct returned by Cldr.Currency.currency_for_code/3 Options :locale is any locale returned by Cldr.Locale.new!/2 . The default is Cldr.get_locale/0 :backend is any module that includes use Cldr and therefore is a Cldr backend module. The default is Cldr.default_backend!/0 Returns display_name or raises an exception Examples iex&gt; Cldr.Currency . display_name! :AUD , backend : MyApp.Cldr &quot;Australian Dollar&quot; iex&gt; Cldr.Currency . display_name! &quot;AUD&quot; , backend : MyApp.Cldr , locale : &quot;fr&quot; &quot;dollar australien&quot; iex&gt; Cldr.Currency . display_name! &quot;EUR&quot; , backend : MyApp.Cldr , locale : &quot;de&quot; &quot;Euro&quot; #=&gt; Cldr.Currency.display_name! &quot;ZZZ&quot;, backend: MyApp.Cldr ** (Cldr.UnknownCurrencyError) The currency &quot;ZZZ&quot; is invalid","ref":"Cldr.Currency.html#display_name!/2","title":"Cldr.Currency.display_name!/2","type":"function"},{"doc":"","ref":"Cldr.Currency.html#expand_filter/3","title":"Cldr.Currency.expand_filter/3","type":"function"},{"doc":"","ref":"Cldr.Currency.html#historic?/1","title":"Cldr.Currency.historic?/1","type":"function"},{"doc":"See Cldr.Currency.known_currency_codes/0 .","ref":"Cldr.Currency.html#known_currencies/0","title":"Cldr.Currency.known_currencies/0","type":"function"},{"doc":"See Cldr.Currency.known_currency_code?/1 .","ref":"Cldr.Currency.html#known_currency?/1","title":"Cldr.Currency.known_currency?/1","type":"function"},{"doc":"Returns a 2-tuple indicating if the supplied currency code is known. Arguments currency_code is a binary or atom representing an ISO4217 currency code Returns {:ok, currency_code} or {:error, {exception, reason}} Examples iex&gt; Cldr.Currency . known_currency_code &quot;AUD&quot; { :ok , :AUD } iex&gt; Cldr.Currency . known_currency_code &quot;GGG&quot; { :error , { Cldr.UnknownCurrencyError , &quot;The currency \\&quot; GGG \\&quot; is invalid&quot; } }","ref":"Cldr.Currency.html#known_currency_code/1","title":"Cldr.Currency.known_currency_code/1","type":"function"},{"doc":"Returns a boolean indicating if the supplied currency code is known. Arguments currency_code is a binary or atom representing an ISO4217 currency code Returns true or false Examples iex&gt; Cldr.Currency . known_currency_code? &quot;AUD&quot; true iex&gt; Cldr.Currency . known_currency_code? &quot;GGG&quot; false iex&gt; Cldr.Currency . known_currency_code? :XCV false","ref":"Cldr.Currency.html#known_currency_code?/1","title":"Cldr.Currency.known_currency_code?/1","type":"function"},{"doc":"Returns a list of all known currency codes. Example iex&gt; Cldr.Currency . known_currency_codes","ref":"Cldr.Currency.html#known_currency_codes/0","title":"Cldr.Currency.known_currency_codes/0","type":"function"},{"doc":"Returns a Currency struct created from the arguments. Arguments currency is a private use currency code in a format defined by ISO4217 which is X followed by two alphanumeric characters. options is a map of options representing the optional elements of the Cldr.Currency.t struct. Options :name is the name of the currenct. Required. :digits is the precision of the currency. Required. :symbol is the currency symbol. Optional. :narrow_symbol is an alternative narrow symbol. Optional. :round_nearest is the rounding precision such as 0.05 . Optional. :alt_code is an alternative currency code for application use. :cash_digits is the precision of the currency when used as cash. Optional. :cash_round_nearest is the rounding precision when used as cash such as 0.05 . Optional. Returns {:ok, Cldr.Currency.t} or {:error, {exception, message}} Example iex&gt; Cldr.Currency . new ( :XAC , name : &quot;XAC currency&quot; , digits : 0 ) { :ok , % Cldr.Currency { alt_code : :XAC , cash_digits : 0 , cash_rounding : nil , code : :XAC , count : %{ other : &quot;XAC currency&quot; } , digits : 0 , from : nil , iso_digits : 0 , name : &quot;XAC currency&quot; , narrow_symbol : nil , rounding : 0 , symbol : &quot;XAC&quot; , tender : false , to : nil } } iex&gt; Cldr.Currency . new ( :XBC ) { :error , { Cldr.CurrencyAlreadyDefined , &quot;Currency :XBC is already defined.&quot; } } iex&gt; MyApp.Cldr.Currency . new ( :XAB , name : &quot;Private Use Name&quot; ) { :error , &quot;Required options are missing. Required options are [:name, :digits]&quot; } iex&gt; Cldr.Currency . new ( :ZAA , name : &quot;Invalid Private Use Name&quot; , digits : 0 ) { :error , { Cldr.UnknownCurrencyError , &quot;The currency :ZAA is invalid&quot; } }","ref":"Cldr.Currency.html#new/2","title":"Cldr.Currency.new/2","type":"function"},{"doc":"Returns the appropriate currency display name for the currency , based on the plural rules in effect for the locale . Arguments number is an integer, float or Decimal currency is any currency returned by Cldr.Currency.known_currencies/0 locale is any valid locale name returned by Cldr.known_locale_names/1 or a Cldr.LanguageTag struct returned by Cldr.Locale.new!/2 backend is any module that includes use Cldr and therefore is a Cldr backend module options is a keyword list of options Options :locale is any locale returned by Cldr.Locale.new!/2 . The default is &lt;backend&gt;.get_locale/1 Returns {:ok, plural_string} or {:error, {exception, message}} Examples iex&gt; Cldr.Currency . pluralize 1 , :USD , MyApp.Cldr { :ok , &quot;US dollar&quot; } iex&gt; Cldr.Currency . pluralize 3 , :USD , MyApp.Cldr { :ok , &quot;US dollars&quot; } iex&gt; Cldr.Currency . pluralize 12 , :USD , MyApp.Cldr , locale : &quot;zh&quot; { :ok , &quot;美元&quot; } iex&gt; Cldr.Currency . pluralize 12 , :USD , MyApp.Cldr , locale : &quot;fr&quot; { :ok , &quot;dollars des États-Unis&quot; } iex&gt; Cldr.Currency . pluralize 1 , :USD , MyApp.Cldr , locale : &quot;fr&quot; { :ok , &quot;dollar des États-Unis&quot; }","ref":"Cldr.Currency.html#pluralize/4","title":"Cldr.Currency.pluralize/4","type":"function"},{"doc":"Returns a map of private currencies. These comprise all currencies created with Cldr.Currency.new/2 .","ref":"Cldr.Currency.html#private_currencies/0","title":"Cldr.Currency.private_currencies/0","type":"function"},{"doc":"Returns a list of all private currency codes.","ref":"Cldr.Currency.html#private_currency_codes/0","title":"Cldr.Currency.private_currency_codes/0","type":"function"},{"doc":"Returns the strings associated with a currency in a given locale. Arguments currency is an ISO4217 currency code locale is any valid locale name returned by Cldr.known_locale_names/1 or a Cldr.LanguageTag struct returned by Cldr.Locale.new!/2 . backend is any module that includes use Cldr and therefore is a Cldr backend module Returns A list of strings or {:error, {exception, reason}} Example iex&gt; Cldr.Currency . strings_for_currency ( :AUD , &quot;en&quot; , MyApp.Cldr ) |&gt; Enum . sort [ &quot;a$&quot; , &quot;aud&quot; , &quot;australian dollar&quot; , &quot;australian dollars&quot; ] iex&gt; Cldr.Currency . strings_for_currency ( :AUD , &quot;de&quot; , MyApp.Cldr ) |&gt; Enum . sort [ &quot;au$&quot; , &quot;aud&quot; , &quot;australische dollar&quot; , &quot;australischer dollar&quot; ] iex&gt; Cldr.Currency . strings_for_currency ( :AUD , &quot;zh&quot; , MyApp.Cldr ) |&gt; Enum . sort [ &quot;au$&quot; , &quot;aud&quot; , &quot;澳大利亚元&quot; ]","ref":"Cldr.Currency.html#strings_for_currency/3","title":"Cldr.Currency.strings_for_currency/3","type":"function"},{"doc":"","ref":"Cldr.Currency.html#tender?/1","title":"Cldr.Currency.tender?/1","type":"function"},{"doc":"Returns a mapping of all ISO3166 territory codes and a list of historic and the current currency for those territories. Example iex&gt; Cldr.Currency . territory_currencies |&gt; Map . get ( :LT ) %{ EUR : %{ from : ~D[2015-01-01] , to : nil } , LTL : %{ from : nil , to : ~D[2014-12-31] } , LTT : %{ from : nil , to : ~D[1993-06-25] } , SUR : %{ from : nil , to : ~D[1992-10-01] } }","ref":"Cldr.Currency.html#territory_currencies/0","title":"Cldr.Currency.territory_currencies/0","type":"function"},{"doc":"","ref":"Cldr.Currency.html#territory_currencies/1","title":"Cldr.Currency.territory_currencies/1","type":"function"},{"doc":"","ref":"Cldr.Currency.html#territory_currencies!/1","title":"Cldr.Currency.territory_currencies!/1","type":"function"},{"doc":"","ref":"Cldr.Currency.html#unannotated?/1","title":"Cldr.Currency.unannotated?/1","type":"function"},{"doc":"Determines is a new currency is already defined. Example iex&gt; Cldr.Currency . validate_new_currency :XAD { :ok , :XAD } iex&gt; Cldr.Currency . validate_new_currency :USD { :error , { Cldr.CurrencyAlreadyDefined , &quot;Currency :USD is already defined.&quot; } }","ref":"Cldr.Currency.html#validate_new_currency/1","title":"Cldr.Currency.validate_new_currency/1","type":"function"},{"doc":"","ref":"Cldr.Currency.html#t:code/0","title":"Cldr.Currency.code/0","type":"type"},{"doc":"","ref":"Cldr.Currency.html#t:currency_status/0","title":"Cldr.Currency.currency_status/0","type":"type"},{"doc":"","ref":"Cldr.Currency.html#t:filter/0","title":"Cldr.Currency.filter/0","type":"type"},{"doc":"","ref":"Cldr.Currency.html#t:format/0","title":"Cldr.Currency.format/0","type":"type"},{"doc":"","ref":"Cldr.Currency.html#t:t/0","title":"Cldr.Currency.t/0","type":"type"},{"doc":"This module implements bindings around what should be an eternal ETS table, or at least until you decide to terminate it. It works by using &quot;bouncing&quot; GenServers which come up as needed to provide an heir for the ETS table. It operates as follows: An ETS table is created with the provided name and options. Two GenServers are started, an owner and an heir . The ETS table is gifted to the owner , and has the heir set as the heir. If the owner crashes, the heir becomes the owner, and a new GenServer is started and assigned the role of heir . If an heir dies, we attempt to start a new GenServer and notify the owner so that they may change the assigned heir . This means that there should always be an heir to your table, which should ensure that you don't lose anything inside ETS.","ref":"Cldr.Eternal.html","title":"Cldr.Eternal","type":"module"},{"doc":"Returns the heir of a given ETS table. Examples iex&gt; Cldr.Eternal . heir ( :my_table )","ref":"Cldr.Eternal.html#heir/1","title":"Cldr.Eternal.heir/1","type":"function"},{"doc":"Returns the owner of a given ETS table. Examples iex&gt; Cldr.Eternal . owner ( :my_table )","ref":"Cldr.Eternal.html#owner/1","title":"Cldr.Eternal.owner/1","type":"function"},{"doc":"Functionally equivalent to start_link/3 , except that the link to the starting process is removed after the table is started. Examples iex&gt; Cldr.Eternal . start ( :table1 , [ ] , [ quiet : true ] ) iex&gt; Cldr.Eternal . start ( :table2 , [ :compressed ] , [ quiet : true ] ) iex&gt; Cldr.Eternal . start ( :table3 , [ ] , [ quiet : true ] )","ref":"Cldr.Eternal.html#start/3","title":"Cldr.Eternal.start/3","type":"function"},{"doc":"Creates a new ETS table using the provided ets_opts . These options are passed through as-is, with the exception of prepending the :public and :named_table options. Seeing as you can't execute inside the GenServers, your table will have to be public to be interacted with. Options You may provide a third parameter containing Eternal options: :name - override the default naming scheme and use a custom name for this table. Remember to use this name when calling stop/1 . :quiet - by default, Eternal logs debug messages. Setting this to true will disable this logging. Examples iex&gt; Cldr.Eternal . start_link ( :table1 , [ ] , [ quiet : true ] ) iex&gt; Cldr.Eternal . start_link ( :table2 , [ :compressed ] , [ quiet : true ] ) iex&gt; Cldr.Eternal . start_link ( :table3 , [ ] , [ quiet : true ] )","ref":"Cldr.Eternal.html#start_link/3","title":"Cldr.Eternal.start_link/3","type":"function"},{"doc":"Terminates both servers in charge of a given ETS table. Note: this will terminate your ETS table. Examples iex&gt; Cldr.Eternal . stop ( :my_table ) :ok","ref":"Cldr.Eternal.html#stop/1","title":"Cldr.Eternal.stop/1","type":"function"},{"doc":"","ref":"Cldr.Eternal.html#t:on_start/0","title":"Cldr.Eternal.on_start/0","type":"type"},{"doc":"Exception raised when an attempt is save a new currency to the ETS table is not successful.","ref":"Cldr.CurencyNotSavedError.html","title":"Cldr.CurencyNotSavedError","type":"exception"},{"doc":"Cldr Currencies Packages the currency definitions from CLDR into a set of functions to return currency data.","ref":"readme.html","title":"Cldr Currencies","type":"extras"},{"doc":"The package can be installed by adding ex_cldr_currencies to your list of dependencies in mix.exs : def deps do [ { :ex_cldr_currencies , &quot;~&gt; 2.5&quot; } ] end","ref":"readme.html#installation","title":"Cldr Currencies - Installation","type":"extras"},{"doc":"ISO4217 permits the creation of private use currencies. These are denoted by currencies that start with &quot;X&quot; followed by two characters. New currencies can be created with Cldr.Currency.new/2 however in order to do so a supervisor must be started which maintains an :ets table that holds the custom currencies. Since the currencies are stored in an :ets table they are transient and will be lost on application restart. It is the developers responsibility to define the required private use currencies on application restart. One option is to use a callback function as described below. Starting the private use currency supervisor The simplest way to start the private use currency supervisor is: iex&gt; Cldr.Currency . start_link ( ) The preferred method however is to add the supervisor to your applications supervision tree. In your application module (ie the one that includes use Application ): defmodule MyApp do use Application def start ( _type , _args ) do # Start the service which maintains the # :ets table that holds the private use currencies children = [ Cldr.Currency ... ] opts = [ strategy : :one_for_one , name : MoneyTest.Supervisor ] Supervisor . start_link ( children , opts ) end end Loading private use currencies at application start If private use currencies are required then defining them when the application starts can be accomplished by providing a callback to the Cldr.Currency supervisor as either a {Module, :function, args} tuple or as an anonymous function that takes two arguments. Here are some examples: # Using an anonymous function defmodule MyApp.Application do use Application def start ( _type , _args ) do # Start the service which maintains the # :ets table that holds the private use currencies children = [ { Cldr.Currency , [ callback : fn pid , table -&gt; &quot; \#{ inspect pid } : Starting private use currency store for \#{ inspect table } &quot; end ] } ] opts = [ strategy : :one_for_one , name : MyApp.Supervisor ] Supervisor . start_link ( children , opts ) end end # Using an MFA defmodule MyApp.Application do use Application def start ( _type , _args ) do # In this example, the `pid` and `table` will be # prepended to the `args`. In this example therefore # the callback will be `MyAppModule.my_function(pid, table)` children = [ { Cldr.Currency , [ callback : { MyAppModule , :my_function , [ ] } ] } ] opts = [ strategy : :one_for_one , name : MyApp.Supervisor ] Supervisor . start_link ( children , opts ) end end","ref":"readme.html#defining-private-use-currencies","title":"Cldr Currencies - Defining private use currencies","type":"extras"},{"doc":"Changelog","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"This is the changelog for Cldr_Currencies v2.10.0 released on June 17th, 2021. For older changelogs please consult the release tag on GitHub Enhancements Allow %Currency{} structs in currency_for_code/3 . Thanks to @jeroenvisser101 for the PR. Improves the performance by up to 40x when validating currencies when the currency has already been pre-constructed. Add implementation of the Inspect protocol for t:Cldr.Currency structs.","ref":"changelog.html#cldr_currencies-v2-10-0","title":"Changelog - Cldr_Currencies v2.10.0","type":"extras"},{"doc":"This is the changelog for Cldr_Currencies v2.9.0 released on April 8th, 2021. For older changelogs please consult the release tag on GitHub Enhancements Depends upon ex_cldr version 2.20 which embodies CLDR39 data. Add Cldr.Currency.display_name/2 that returns a localized display name suitable for use in UI applications. Add implementation of String.Chars and Cldr.Chars protocols for t:Cldr.Currency structs.","ref":"changelog.html#cldr_currencies-v2-9-0","title":"Changelog - Cldr_Currencies v2.9.0","type":"extras"},{"doc":"This is the changelog for Cldr_Currencies v2.9.0-rc.1 released on March 24th, 2021. For older changelogs please consult the release tag on GitHub Enhancements Add Cldr.Currency.display_name/2 that returns a localized display name suitable for use in UI applications. Add implementation of String.Chars and Cldr.Chars protocols for t:Cldr.Currency structs.","ref":"changelog.html#cldr_currencies-v2-9-0-rc-1","title":"Changelog - Cldr_Currencies v2.9.0-rc.1","type":"extras"},{"doc":"This is the changelog for Cldr_Currencies v2.9.0-rc.0 released on March 19th, 2021. For older changelogs please consult the release tag on GitHub Enhancements Depends upon ex_cldr version 2.20 which embodies CLDR39 data.","ref":"changelog.html#cldr_currencies-v2-9-0-rc-0","title":"Changelog - Cldr_Currencies v2.9.0-rc.0","type":"extras"},{"doc":"This is the changelog for Cldr_Currencies v2.8.0 released on November 1st, 2020. For older changelogs please consult the release tag on GitHub Enhancements Add support for CLDR 38","ref":"changelog.html#cldr_currencies-v2-8-0","title":"Changelog - Cldr_Currencies v2.8.0","type":"extras"},{"doc":"This is the changelog for Cldr_Currencies v2.7.0 released on September 25th, 2020. For older changelogs please consult the release tag on GitHub Enhancements Use Cldr.default_backend!/0 when available since Cldr.default_backend/0 is deprecated as of ex_cldr version 2.18.0","ref":"changelog.html#cldr_currencies-v2-7-0","title":"Changelog - Cldr_Currencies v2.7.0","type":"extras"},{"doc":"This is the changelog for Cldr_Currencies v2.6.2 released on August 31st, 2020. For older changelogs please consult the release tag on GitHub Bug Fixes Uses Supervisor.child_spec/2 for eternal workers to remove deprecation warning on Elixir 1.11","ref":"changelog.html#cldr_currencies-v2-6-2","title":"Changelog - Cldr_Currencies v2.6.2","type":"extras"},{"doc":"This is the changelog for Cldr_Currencies v2.6.1 released on July 19th, 2020. For older changelogs please consult the release tag on GitHub Bug Fixes Make dialyzer happy. The @spec s for Cldr.Eternal.start_link/1 and Cldr.Eternal.start_link/0 however remain a mystery and are commented out for now - success typing seems happy nevertheless.","ref":"changelog.html#cldr_currencies-v2-6-1","title":"Changelog - Cldr_Currencies v2.6.1","type":"extras"},{"doc":"This is the changelog for Cldr_Currencies v2.6.0 released on July 18th, 2020. For older changelogs please consult the release tag on GitHub Breaking change Remove Cldr.Currency.make_currency_code/1 whose need is replaced by Cldr.validate_currency/1 . Deprecations Deprecate Cldr.Currency.known_currency?/1 in favour of Cldr.Currency.known_currency_code?/1 Deprecate Cldr.Currency.known_currencies/0 in favour of Cldr.Currency.known_currency_codes/0 Enhancements Support the creation of private use currencies with Cldr.Currency.new/2 . Newly created private use currencies are stored in an :ets table which means that currencies will need to be recreated on each application restart. Creating the currencies is a developer responsibility although this may change in the future. In order to create currencies a supervisor and :ets table owner must be started. See the README for further details on adding the private use currency store to your application supervision tree. Add :alt_code to the Cldr.Currency struct. When creating a new currency, the currency code must conform to ISO4217 meaning that any new code must be in the &quot;private use&quot; range. This in turn means that the currency code must start with &quot;X&quot; and be three characters long. Many crypto currencies have either conflicting currency codes (do not comply with ISO4217 private use) or are invalid codes (longer than three characters). The :alt_code can be used to store an arbitrary alternative currency code than can be used to identify cryptocurrencies by a more familiar code.","ref":"changelog.html#cldr_currencies-v2-6-0","title":"Changelog - Cldr_Currencies v2.6.0","type":"extras"},{"doc":"This is the changelog for Cldr_Currencies v2.5.0 released on May 2nd, 2020. For older changelogs please consult the release tag on GitHub Enhancements Add Cldr.Currency.currency_from_locale/{1, 2} Add Cldr.Currency.current_currency_from_locale/1 Add Cldr.Currency.current_currency_from_territory/1 Add Cldr.Currency.currency_format_from_locale/1 Add &lt;backend&gt;.currency_from_locale/{1, 2}","ref":"changelog.html#cldr_currencies-v2-5-0","title":"Changelog - Cldr_Currencies v2.5.0","type":"extras"},{"doc":"This is the changelog for Cldr_Currencies v2.4.1 released on November 7th, 2019. For older changelogs please consult the release tag on GitHub Bug Fixes In some rare cases, currency strings have a trailing . . These are now removed when producing currency strings that are used for parsing money amounts in ex_money .","ref":"changelog.html#cldr_currencies-v2-4-1","title":"Changelog - Cldr_Currencies v2.4,1","type":"extras"},{"doc":"This is the changelog for Cldr_Currencies v2.4.0 released on November 6th, 2019. For older changelogs please consult the release tag on GitHub Enhancements Adds the options :only and :except to Cldr.Currency.filter_currencies/3 . These options are exercised in ex_money in the Money.parse/2 function to limited parsed user input to a particular set of currencies.","ref":"changelog.html#cldr_currencies-v2-4-0","title":"Changelog - Cldr_Currencies v2.4.0","type":"extras"},{"doc":"This is the changelog for Cldr_Currencies v2.3.0 released on March 28th, 2019. For older changelogs please consult the release tag on GitHub Enhancements Updates to CLDR version 35.0.0 released on March 27th 2019.","ref":"changelog.html#cldr_currencies-v2-3-0","title":"Changelog - Cldr_Currencies v2.3.0","type":"extras"},{"doc":"This is the changelog for Cldr_Currencies v2.2.5 released on March 15th, 2019. For older changelogs please consult the release tag on GitHub Bug Fixes Fix dialyzer warnings","ref":"changelog.html#cldr_currencies-v2-2-5","title":"Changelog - Cldr_Currencies v2.2.5","type":"extras"},{"doc":"This is the changelog for Cldr_Currencies v2.2.4 released on March 15th, 2019. For older changelogs please consult the release tag on GitHub Enhancements Makes generation of documentation for backend modules optional. This is implemented by the :generate_docs option to the backend configuration. The default is true . For example: defmodule MyApp.Cldr do use Cldr , default_locale : &quot;en-001&quot; , locales : [ &quot;en&quot; , &quot;ja&quot; ] , gettext : MyApp.Gettext , generate_docs : false end ## Cldr_Currencies v2.2.3 This is the changelog for Cldr_Currencies v2 . 2.3 released on March 7 th , 2019 . For older changelogs please consult the release tag on [ GitHub ] ( https :/ / github . com / elixir - cldr / cldr_currencies / tags ) ### Bug Fixes * Fix or silence all remaining dialyzer warnings for real this time ## Cldr_Currencies v2.2.2 This is the changelog for Cldr_Currencies v2 . 2.2 released on March 7 th , 2019 . For older changelogs please consult the release tag on [ GitHub ] ( https :/ / github . com / elixir - cldr / cldr_currencies / tags ) ### Bug Fixes * Fix or silence all remaining dialyzer warnings ## Cldr_Currencies v2.2.1 This is the changelog for Cldr_Currencies v2 . 2.1 released on March 6 th , 2019 . For older changelogs please consult the release tag on [ GitHub ] ( https :/ / github . com / elixir - cldr / cldr_currencies / tags ) ### Bug Fixes * Fix or silence dialyzer warnings ## Cldr_Currencies v2.2.0 This is the changelog for Cldr_Currencies v2 . 2.0 released on February 23 nd , 2019 . For older changelogs please consult the release tag on [ GitHub ] ( https :/ / github . com / elixir - cldr / cldr_currencies / tags ) ### Enhancements This release adds mapping data from a territory to a list of currencies and functions to access them . This allows for identifying the current currency for a given locale . * Adds ` Cldr.Currency . currency_history_for_locale / 2 ` * Adds ` Cldr.Currency . current_currency_for_locale / 2 ` * Adds ` Cldr.Currency . territory_currencies / 0 ` Some examples : iex&gt; Cldr.Currency.territory_currencies |&gt; Map.get(&quot;LT&quot;) %{ EUR: %{from: ~D[2015-01-01], to: nil}, LTL: %{from: nil, to: ~D[2014-12-31]}, LTT: %{from: nil, to: ~D[1993-06-25]}, SUR: %{from: nil, to: ~D[1992-10-01]} } iex&gt; Cldr.Currency.currency_history_for_locale &quot;en&quot;, MyApp.Cldr %{ USD: %{from: ~D[1792-01-01], to: nil}, USN: %{tender: false}, USS: %{from: nil, tender: false, to: ~D[2014-03-01]} } iex&gt; Cldr.Currency.current_currency_for_locale &quot;en&quot;, MyApp.Cldr :USD iex&gt; Cldr.Currency.current_currency_for_locale &quot;en-AU&quot;, MyApp.Cldr :AUD ## Cldr_Currencies v2.1.4 This is the changelog for Cldr_Currencies v2 . 1.4 released on February 22 nd , 2019 . For older changelogs please consult the release tag on [ GitHub ] ( https :/ / github . com / elixir - cldr / cldr_currencies / tags ) ### Bug Fixes * Fixes significant performance regression in ` Cldr.Currency . currencies_for_locale / 2 ` . Thanks to @doughsay for the issue . Closes #98 in [money](https://github.com/elixir-cldr/money). ## Cldr_Currencies v2.1.3 This is the changelog for Cldr_Currencies v2 . 1.3 released on February 18 th , 2019 . For older changelogs please consult the release tag on [ GitHub ] ( https :/ / github . com / elixir - cldr / cldr_currencies / tags ) ### Bug Fixes * Updates ` ex_cldr ` to fix the regex that parses currency names used for money parsing ## Cldr_Currencies v2.1.2 This is the changelog for Cldr_Currencies v2 . 1.2 released on February 13 th , 2019 . For older changelogs please consult the release tag on [ GitHub ] ( https :/ / github . com / elixir - cldr / cldr_currencies / tags ) ### Bug Fixes * Some different currencies may have the same currency name . This most commonly happens when there are historic currencies with the same name as a current currency . Afghan Afghanis , for example , has the code ` :AFA ` until 2002 when it was replaced by the currency code ` :AFN ` . Now when extracting currency strings , the currency names map only to the current currency and the duplicated are therefore removed . ## Cldr_Currencies v2.1.1 This is the changelog for Cldr_Currencies v2 . 1.1 released on February 10 th , 2019 . For older changelogs please consult the release tag on [ GitHub ] ( https :/ / github . com / elixir - cldr / cldr_currencies / tags ) ### Bug Fixes * Fixes the regex for parsing currency names that have date ranges in them . It now correctly parses names with non - ASCII characters too . * Removes ` Cldr.Currency . all_currency_strings / 2 ` since strings conflict across locales * Add ` Cldr.Currency . currency_strings / 2 ` ### Enhancements * Added ` :unannotated ` to ` Cldr.Currency . currency_filter / 2 ` . It omits currency names that have a &quot;(...)&quot; in then since these are typically financial instruments . ## Cldr_Currencies v2.1.0 This is the changelog for Cldr_Currencies v2 . 1.0 released on February 9 th , 2019 . For older changelogs please consult the release tag on [ GitHub ] ( https :/ / github . com / elixir - cldr / cldr_currencies / tags ) ### Enhancements The primary goal of this release is to provide a mechanism to support parsing money and currency input from a user . With this in mind , this release adds : * ` Cldr.Currency . currency_strings / 2 ` that returns a list of strings for a currency in a locale against which user input can be compared to identify a currency * ` Cldr.Currency . all_currency_strings / 2 ` which returns a similar list but for all known locales * ` Cldr.Currency . currency_filter / 2 ` that will filter a list currencies based upon whether they are current , historic or legal tender In addition the ` Cldr.Currency . t ` structure has changed : * The ` Cldr.Currency . t ` struct now includes effective dates ` :to ` and ` :from ` . These were previously encoded in the currency name . The currency name no longer includes these dates . ## Cldr_Currencies v2.0.0 This is the changelog for Cldr_Currencies v2 . 0.0 released on November 22 nd , 2018 . For older changelogs please consult the release tag on [ GitHub ] ( https :/ / github . com / elixir - cldr / cldr_currencies / tags ) ### Enhancements * Updated dependency on [ ex_cldr ] ( https :/ / hex . pm / packages / ex_cldr ) to version 2.0 . 0 . * Remove Poison from optional dependencies ( can still be configured in a client app ) ### Breaking Changes * ` Currency . currency_for_code / 3 ` has a changed function signature and it now requires a backend module to be specified . It also supports an option ` :locale ` to specify the locale . The default is the default locale of the specified backend . Cldr.Currency.currency_for_locale(:USD, MyApp.Cldr, locale: &quot;en&quot;) The @spec for the new signature is : @spec currency_for_code(code, Cldr.backend(), Keyword.t()) :: { :ok , t } | { :error , { module ( ) , String . t ( ) } }","ref":"changelog.html#cldr_currencies-v2-2-4","title":"Changelog - Cldr_Currencies v2.2.4","type":"extras"},{"doc":"","ref":"license.html","title":"LICENSE","type":"extras"},{"doc":"Copyright 2018 Kip Cole Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http :/ / www . apache . org / licenses / LICENSE - 2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"license.html#license","title":"LICENSE - License","type":"extras"}]